GMail Docklet doesn't support Proxy

Bug #617478 reported by David Harper on 2010-08-13
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Docky
Medium
Chris S.

Bug Description

Within the corporate environment, we use both Google Apps for Enterprise and Google Web Security Proxy: http://www.google.com/a/help/intl/en/security/websecurity.html

When using the docklet I can authenticate my account successfully, and based on the debug it tries to connect to the correct enterprise domain (mail.google.com/a/[company name]/feed/atom/Inbox), however the applet remains grey with a "Network Error" tooltip.

I'm assuming this is because the applet doesn't respect the Gnome Proxy settings.

Hope you can help :)

[Info 17:37:46.596] Docky version: 2.0.5 Release
[Info 17:37:46.599] Kernel version: 2.6.32.24
[Info 17:37:46.599] CLR version: 2.0.50727.1433
[Debug 17:37:46.795] [UserArgs] BufferTime = 0
[Debug 17:37:46.795] [UserArgs] MaxSize = 2147483647
[Debug 17:37:46.795] [UserArgs] NetbookMode = False
[Debug 17:37:46.795] [UserArgs] NoPollCursor = False
[Info 17:37:46.841] [DockController] Setting theme: Classic
[Info 17:37:46.966] [PluginManager] Loaded "Trash".
[Info 17:37:46.977] [PluginManager] Loaded "Docky.Widgets,1.0".
[Info 17:37:46.977] [PluginManager] Loaded "Docky.Widgets,1.0".
[Info 17:37:46.977] [PluginManager] Loaded "GMail".
[Info 17:37:47.193] [GMailAtom] Fetching Atom feed: https://mail.google.com/a/city-link.com/feed/atom/Inbox

Ubuntu 10.04

Robert Dyer (psybers) wrote :

@Chris: what ever happened to your proxy work? Why was it not merged in?

Changed in docky:
assignee: nobody → Chris S. (cszikszoy)
importance: Undecided → Wishlist
status: New → In Progress
Chris S. (cszikszoy) wrote :

Proxy support is there, not quite sure what's going on.

OP: Can you give me some info on your proxy setup? So you set the proxy via gconf? Can you give me the output of these commands:
gconftool-2 -a /system/proxy
gconftool-2 -a /system/http_proxy

Chris S. (cszikszoy) wrote :

Also, I've just pushed some code that adds more logging when gmail fails in certain ways. Can you please grab the latest from trunk and try again so I can see what the exception message is?

David Harper (inquisitivedave) wrote :

Hi Chris,

I setup the proxy using the standard Gnome proxy tool. I blanked out some of the more sensitive data with *.

gconftool-2 -a /system/http_proxy
 use_authentication = true
 authentication_password = *******************
 authentication_user = *****.*****
 ignore_hosts = [localhost,127.0.0.0/8,*.local,192.168.11.42,192.168.11.11,subkeys.pgp.net,192.168.11.112]
 use_http_proxy = true
 port = 3128
 use_same_proxy = true
 host = ***gws01.*********.co.uk

gconftool-2 -a /system/proxy
 old_ftp_port = 0
 old_ftp_host =
 old_secure_port = 0
 old_secure_host =
 autoconfig_url =
 mode = manual
 ftp_host = ***gws01.*********.co.uk
 secure_host = ***gws01.*********.co.uk
 secure_port = 3128
 socks_host = ***gws01.*********.co.uk
 socks_port = 3128
 ftp_port = 3128
 old_socks_port = 0
 old_socks_host =

I'll have to go home first and download trunk, then bring it back into work, as the corporate firewall blocks the port Bazaar runs on.

David Harper (inquisitivedave) wrote :

[Info 09:58:34.315] Docky version: 2.1.0 bzr docky r1609 ppa
[Info 09:58:34.321] Kernel version: 2.6.32.24
[Info 09:58:34.322] CLR version: 2.0.50727.1433
[Info 09:58:35.809] [GMailAtom] Fetching Atom feed: https://mail.google.com/a/***********.com/feed/atom/Inbox
[Error 09:58:35.872] [GMailAtom] Network error: Error: ConnectFailure
[Error 09:58:35.872] [SystemService] Error in RunOnThread: Object reference not set to an instance of an object
[Debug 09:58:35.874] [SystemService] at GMail.GMailAtom+<CheckGMail>c__AnonStorey1.<>m__9 () [0x00557] in /build/buildd/docky-2.1.0~bzr1609/StandardPlugins/GMail/src/GMailAtom.cs:290
  at Docky.Services.SystemService+<RunOnThread>c__AnonStoreyB.<>m__11 () [0x00000] in /build/buildd/docky-2.1.0~bzr1609/Docky.Services/Docky.Services/SystemService.cs:469

[Info 10:18:22.805] [GMailAtom] Fetching Atom feed: https://mail.google.com/a/city-link.com/feed/atom/Inbox
[Error 10:18:22.814] [GMailAtom] Network error: Error getting response stream (The remote server returned a 407 status code.): SecureChannelFailure

407 is for the Proxy Authentication being denied. I've entered my Proxy Authentication into the Details tab of the Gnome Proxy panel.

Chris S. (cszikszoy) wrote :

Interesting... Just to be clear, this is a http proxy, right? I see from your gconf dump that you have the same proxy listed as the socks_host and ftp_host. I assume you don't have proxy related problems with other apps? I might have to make some small test programs to fully debug this proxy issue. Do you mind running a few small programs? I'll provide source and tell you how to compile it just so you make sure there's no malicious intent. Also, this may well end up being a bug with Mono, so I'll have to do some digging to find out more.

Chris S. (cszikszoy) wrote :

Also, I'll have to do some work on this in a branch, are you comfortable with building docky from source?

Yes. The same proxy handles all traffic to the outside world (as long
as the port isn't blocked). I don't have issues with Empathy, Firefox,
Chrome, etc...

With the web browsers, it seems they make the request first
unauthenticated. Then they get a 407 back... only then do they try to
supply the username/password. I'm not sure if there is method to the
madness there or not.

I don't mind compiling from source, it just takes a while due to the
Bazaar blocking. I think I got all the prerequisites for building this
morning.

On 17/08/2010, Chris S. <email address hidden> wrote:
> Interesting... Just to be clear, this is a http proxy, right? I see
> from your gconf dump that you have the same proxy listed as the
> socks_host and ftp_host. I assume you don't have proxy related problems
> with other apps? I might have to make some small test programs to fully
> debug this proxy issue. Do you mind running a few small programs? I'll
> provide source and tell you how to compile it just so you make sure
> there's no malicious intent. Also, this may well end up being a bug
> with Mono, so I'll have to do some digging to find out more.
>
> --
> GMail Docklet doesn't support Proxy
> https://bugs.launchpad.net/bugs/617478
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Chris S. (cszikszoy) on 2010-08-18
Changed in docky:
importance: Wishlist → Medium
milestone: none → 2.1.0
Chris S. (cszikszoy) wrote :

Ok, I hope my branch might fix it. Please try lp:~cszikszoy/docky/bug-617478

In case this is extremely hard for you to test at work (due to bzr being blocked), I've also attached a compiled binary of the gmail plugin. You should just be able to replace the installed one with the one I'm attaching to this bug report, as long as you're on 32bit.

Chris S. (cszikszoy) wrote :
David Harper (inquisitivedave) wrote :

Hi Chris, I'm running 64bit Ubuntu.
I will checkout you branch tonight and give it a whirl tomorrow.

Thanks :)

On 18 Aug 2010 14:01, "Chris S." <email address hidden> wrote:

Ok, I hope my branch might fix it. Please try

lp:~cszikszoy/docky/bug-617478
In case this is extremely hard for you to test at work (due to bzr being
blocked), I've also attached a compiled binary of the gmail plugin. You
should just be able to replace the installed one with the one I'm
attaching to this bug report, as long as you're on 32bit.

--
GMail Docklet doesn't support Proxy
https://bugs.launchpad.net/bugs/617478
You received this bu...

Chris S. (cszikszoy) wrote :

On Wed, Aug 18, 2010 at 1:04 PM, David Harper <email address hidden>wrote:

> Hi Chris, I'm running 64bit Ubuntu.
>

It might be worth trying, the plugins might be arch independent. I can't
remember. The worst you could do is back up the old one, and copy the one I
linked.

> I will checkout you branch tonight and give it a whirl tomorrow.
>
> Thanks :)
>
>

David Harper (inquisitivedave) wrote :

Hi Chris,

I've got your branch now, and I've tried following the instructions here: http://wiki.go-docky.com/index.php?title=Installing for compiling from source, however I'm getting an error on the make install part

Making install in Docky.CairoHelper
make[1]: Entering directory `/home/dave/code/docky/docky/Docky.CairoHelper'
make[2]: Entering directory `/home/dave/code/docky/docky/Docky.CairoHelper'
make[2]: Nothing to be done for `install-exec-am'.
test -z "/usr/local/lib/docky" || /bin/mkdir -p "/usr/local/lib/docky"
 /usr/bin/install -c -m 644 ../build/Docky.CairoHelper.dll ./../build/Docky.CairoHelper.dll.mdb '/usr/local/lib/docky'
/usr/bin/install: cannot stat `./../build/Docky.CairoHelper.dll.mdb': No such file or directory

There are no .mdb files within the build directory.
make[2]: *** [install-moduleDATA] Error 1
make[2]: Leaving directory `/home/dave/code/docky/docky/Docky.CairoHelper'
make[1]: *** [install-am] Error 2
make[1]: Leaving directory `/home/dave/code/docky/docky/Docky.CairoHelper'
make: *** [install-recursive] Error 1

David Harper (inquisitivedave) wrote :

I tried just copying the built GMail.dll into the currently install Docky directory, but that broke things totally and Docky wouldn't start.

Robert Dyer (psybers) wrote :

Try doing:

./autogen.sh --enable-debug=yes

and then do a:

make clean && make && sudo make install

David Harper (inquisitivedave) wrote :

That worked, thanks. Here is the debug output from Docky:

[Info 15:42:55.599] Docky version: 2.1.0 bzr docky r1614
[Info 15:42:55.605] Kernel version: 2.6.32.24
[Info 15:42:55.605] CLR version: 2.0.50727.1433

[Info 15:42:57.066] [PluginManager] Loaded "GMail".
[Info 15:42:57.932] [GMailAtom] Fetching Atom feed: https://mail.google.com/a/***********/feed/atom/Inbox
[Info 15:42:57.948] [Helper] Starting banshee_control.py
[Debug 15:42:57.970] [GMailAtom] Preauthenticating...
[Info 15:42:57.974] [Helper] Starting zeitgeist_journal.py
[Info 15:42:58.032] [Helper] Starting zeitgeist_menus.py
[Info 15:42:58.050] [HelperService] Helper added: /usr/share/dockmanager/scripts/banshee_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/deluge_badge.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/emesene_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/gajim_badge.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/gtg_menus.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/liferea_badge.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/mpd_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/open_terminal_here.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/pidgin_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/rhythmbox_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/skype_control.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/tomboy_menus.py
[Info 15:42:58.051] [HelperService] Helper added: /usr/share/dockmanager/scripts/transmission_badge.py
[Info 15:42:58.052] [HelperService] Helper added: /usr/share/dockmanager/scripts/tsclient_menus.py
[Info 15:42:58.052] [HelperService] Helper added: /usr/share/dockmanager/scripts/zeitgeist_journal.py
[Info 15:42:58.052] [HelperService] Helper added: /usr/share/dockmanager/scripts/zeitgeist_menus.py
[Error 15:42:58.122] [GMailAtom] Network error: Error: ConnectFailure
[Error 15:42:58.122] [SystemService] Error in RunOnThread: Object reference not set to an instance of an object
[Debug 15:42:58.123] [SystemService] at GMail.GMailAtom+<CheckGMail>c__AnonStorey1.<>m__9 () [0x0056e] in /home/dave/code/docky/docky/StandardPlugins/GMail/src/GMailAtom.cs:296
  at Docky.Services.SystemService+<RunOnThread>c__AnonStorey37.<>m__60 () [0x00000] in /home/dave/code/docky/docky/Docky.Services/Docky.Services/SystemService.cs:487

Chris S. (cszikszoy) wrote :

Do you have any problems using any of the other network enabled plugins, like weather or NPR?

David Harper (inquisitivedave) wrote :
Download full text (6.8 KiB)

Trying all the providers I get nothing, and a grey icon on the bar.

[Info 18:43:18.172] [PluginManager] Loaded "Weather".
[Debug 18:43:18.251] [Preferences] Key Timeout does not exist, creating.
[Debug 18:43:18.498] [Preferences] Key Location does not exist, creating.
[Debug 18:43:32.631] [AbstractWeatherSource] iGoogle: Fetching XML file 'http://api.wunderground.com/auto/wui/geo/GeoLookupXML/index.xml?query=Bracknell%2c+UK'
[Info 18:43:36.027] [AbstractWeatherSource] iGoogle: Reloading weather data
[Debug 18:43:36.028] [AbstractWeatherSource] iGoogle: Fetching XML file 'http://www.google.com/ig/api?hl=en&weather=Bracknell%2c+UK'
[Debug 18:43:36.030] [AbstractWeatherSource] iGoogle: error: Invalid Weather Location
[Debug 18:43:36.031] [AbstractWeatherSource] iGoogle: Object reference not set to an instance of an object at System.Net.WebConnectionGroup.PrepareSharingNtlm (System.Net.WebConnection cnc, System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.CreateOrReuseConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.GetConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.ServicePoint.SendRequest (System.Net.HttpWebRequest request, System.String groupName) [0x00000]
  at System.Net.HttpWebRequest.BeginGetResponse (System.AsyncCallback callback, System.Object state) [0x00000]
  at System.Net.HttpWebRequest.GetResponse () [0x00000]
  at WeatherDocklet.AbstractWeatherSource.FetchXml (System.String url) [0x0006d] in /home/dave/code/docky/docky/StandardPlugins/Weather/src/Sources/AbstractWeatherSource.cs:343
  at WeatherDocklet.AbstractWeatherSource.FetchAndParse (System.String url, WeatherDocklet.XmlParser parser) [0x00011] in /home/dave/code/docky/docky/StandardPlugins/Weather/src/Sources/AbstractWeatherSource.cs:301
[Info 18:44:00.115] [AbstractWeatherSource] Weather Channel: Reloading weather data
[Debug 18:44:00.116] [AbstractWeatherSource] Weather Channel: Fetching XML file 'http://xoap.weather.com/weather/local/Bracknell%2c+UK?cc=*&dayf=10&prod=xoap&par=1097943453&link=xoap&key=306225326138d0bd&unit=s'
[Debug 18:44:00.116] [AbstractWeatherSource] Weather Channel: error: Invalid Weather Location
[Debug 18:44:00.117] [AbstractWeatherSource] Weather Channel: Object reference not set to an instance of an object at System.Net.WebConnectionGroup.PrepareSharingNtlm (System.Net.WebConnection cnc, System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.CreateOrReuseConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.GetConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.ServicePoint.SendRequest (System.Net.HttpWebRequest request, System.String groupName) [0x00000]
  at System.Net.HttpWebRequest.BeginGetResponse (System.AsyncCallback callback, System.Object state) [0x00000]
  at System.Net.HttpWebRequest.GetResponse () [0x00000]
  at WeatherDocklet.AbstractWeatherSource.FetchXml (System.String url) [0x0006d] in /home/dave/code/docky/docky/StandardPlugins/Weather/src/Sources/AbstractWeatherSource.cs:343
  at WeatherDocklet.AbstractWeatherSource.FetchAndParse (Sys...

Read more...

David Harper (inquisitivedave) wrote :
Download full text (4.1 KiB)

For NPR radio...

[Info 18:47:35.752] [PluginManager] Loaded "NPR".
[Error 18:47:40.650] [SystemService] Error in RunOnThread: Object reference not set to an instance of an object
[Debug 18:47:40.650] [SystemService] at System.Net.WebConnectionGroup.PrepareSharingNtlm (System.Net.WebConnection cnc, System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.CreateOrReuseConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.GetConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.ServicePoint.SendRequest (System.Net.HttpWebRequest request, System.String groupName) [0x00000]
  at System.Net.HttpWebRequest.BeginGetResponse (System.AsyncCallback callback, System.Object state) [0x00000]
  at System.Net.HttpWebRequest.GetResponse () [0x00000]
  at NPR.NPR.APIReturn (System.String url, System.Collections.Specialized.NameValueCollection query) [0x0004c] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/NPR.cs:103
  at NPR.NPR.SearchStations (System.String zip) [0x00012] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/NPR.cs:122
  at NPR.StationSearchWidget.<SearchClicked>m__F () [0x00000] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/StationSearchWidget.cs:68
  at Docky.Services.SystemService+<RunOnThread>c__AnonStorey37.<>m__60 () [0x00000] in /home/dave/code/docky/docky/Docky.Services/Docky.Services/SystemService.cs:487
[Error 18:47:49.575] [SystemService] Error in RunOnThread: Object reference not set to an instance of an object
[Debug 18:47:49.575] [SystemService] at System.Net.WebConnectionGroup.PrepareSharingNtlm (System.Net.WebConnection cnc, System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.CreateOrReuseConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.GetConnection (System.Net.HttpWebRequest request) [0x00000]
  at System.Net.ServicePoint.SendRequest (System.Net.HttpWebRequest request, System.String groupName) [0x00000]
  at System.Net.HttpWebRequest.BeginGetResponse (System.AsyncCallback callback, System.Object state) [0x00000]
  at System.Net.HttpWebRequest.GetResponse () [0x00000]
  at NPR.NPR.APIReturn (System.String url, System.Collections.Specialized.NameValueCollection query) [0x0004c] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/NPR.cs:103
  at NPR.NPR.SearchStations (System.String zip) [0x00012] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/NPR.cs:122
  at NPR.StationSearchWidget.<SearchClicked>m__F () [0x00000] in /home/dave/code/docky/docky/StandardPlugins/NPR/src/StationSearchWidget.cs:68
  at Docky.Services.SystemService+<RunOnThread>c__AnonStorey37.<>m__60 () [0x00000] in /home/dave/code/docky/docky/Docky.Services/Docky.Services/SystemService.cs:487
[Error 18:47:51.017] [SystemService] Error in RunOnThread: Object reference not set to an instance of an object
[Debug 18:47:51.017] [SystemService] at System.Net.WebConnectionGroup.PrepareSharingNtlm (System.Net.WebConnection cnc, System.Net.HttpWebRequest request) [0x00000]
  at System.Net.WebConnectionGroup.CreateOrReuseConnection (System.Net.HttpWebRequest request)...

Read more...

Robert Dyer (psybers) wrote :

@Chris: any updates on this in the last 3 weeks?

Rico Tzschichholz (ricotz) wrote :

@Chris: same question ;-). Is your branch already fixing this?

Changed in docky:
milestone: 2.1.0 → none
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Bug attachments